<? 
// Rookmarks - tool for administering live RSS bookmarks
// Copyright (C) 2007 Brian Enigma <brian@netninja.com>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
session_start(); 
?>
<html><head><title>Link Administration</title>
<link rel="shortcut icon" href="favicon.gif" type="image/gif">
<link rel="icon" href="favicon.gif" type="image/gif">
</head><body>
<?
require_once("./lib/users.php");
require_once("./lib/links.php");

if (!isLoggedIn())
	exit("Not logged in");
	
$links = new Links;
$links->loadLinks();
$op = isset($_POST['op']) ? $_POST['op'] : "";
$index = isset($_POST['index']) ? floor($_POST['index']) : -1;

if (strcmp($op, "add") == 0) {
	$link = new Link;
	$link->url = $_POST['url'];
	$link->title = $_POST['title'];
	$links->addLink($link);
} elseif (strcmp($op, "write") == 0) {
	$link = "http://" . $_SERVER['SERVER_NAME'] . 
		($_SERVER['SERVER_PORT'] != 80 ? ":" . $_SERVER['SERVER_PORT'] : "") .
		$_SERVER["REQUEST_URI"];
	if (($pos = strrpos($link, "/")) !== FALSE)
		$link = substr($link, 0, $pos);
	$links->writeRSS($siteName, $link, "Rookmarks");
} elseif (strcmp($op, "remove") == 0) {
	$links->removeItem($index);
} elseif (strcmp($op, "up") == 0) {
	$links->moveItem($index, -1);
} elseif (strcmp($op, "down") == 0) {
	$links->moveItem($index, 1);
} elseif (strcmp($op, "rename") == 0) {
	setSiteName($_POST['name']);
	include("./lib/settings.php");
}
readOnlyWarning();
?>
<small><a href="admin.php">&lt;== back to admin</a></small>
<h2>Current link list for <?= $siteName ?></h2>
<form method="post" name="bookmarkList">
<input type="hidden" name="op" />
<input type="hidden" name="index" />
<table border="0" cellspacing="0" cellpadding="3">
<? for ($i=0; $i<sizeof($links->links); $i++) { ?>
	<tr>
	<td><a href="<?= $links->links[$i]->url ?>"><?= $links->links[$i]->url ?></a></td>
	<td><?=  $links->links[$i]->title ?></td>
	<td>[<a href="#" onclick="return removeItem(<?= $i ?>);">remove</a>]
		[<a href="#" onclick="return moveUp(<?= $i ?>);">up</a>]
		[<a href="#" onclick="return moveDown(<?= $i ?>);">down</a>]
		</td>
	</tr>
<? } ?>
</table>
</form>
<? if (sizeof($links->links) == 0) print("(none)<br />"); ?>

<h2>Add Bookmark</h2>
<form method="post" name="addForm">
<input type="hidden" name="op" value="add">
<table border="0" cellspacing="0" cellpadding="3">
<tr><td>URL:</td><td><input type="text" name="url" /></td></tr>
<tr><td>Title:</td><td><input type="text" name="title" /></td></tr>
<tr><td></td><td align="right"><input type="submit" value="Add" /></td></tr>
</table>
</form>

<h2>Write RSS File</h2>
Click the button to write a new <a href="index.xml">RSS Live Bookmark file</a>.
<form method="post">
<input type="hidden" name="op" value="write">
<input type="submit" value="Write" />
</form>

<h2>Change Site Name</h2>
<form method="post">
<input type="hidden" name="op" value="rename">
<input type="text" name="name" value="<?= htmlentities($siteName) ?>" />
<input type="submit" value="Rename" />
</form>

<script language="JavaScript" type="text/javascript">
document.forms['addForm'].elements['url'].focus();
function removeItem(i) {
	document.forms['bookmarkList'].elements['op'].value = 'remove';
	document.forms['bookmarkList'].elements['index'].value = i;
	document.forms['bookmarkList'].submit();
	return false;
}
function moveUp(i) {
	document.forms['bookmarkList'].elements['op'].value = 'up';
	document.forms['bookmarkList'].elements['index'].value = i;
	document.forms['bookmarkList'].submit();
	return false;
}
function moveDown(i) {
	document.forms['bookmarkList'].elements['op'].value = 'down';
	document.forms['bookmarkList'].elements['index'].value = i;
	document.forms['bookmarkList'].submit();
	return false;
}
</script>
</body></html>