<? 
// Rookmarks - tool for administering live RSS bookmarks
// Copyright (C) 2007 Brian Enigma <brian@netninja.com>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
session_start(); 
?>
<html><head><title>User Administration</title>
<link rel="shortcut icon" href="favicon.gif" type="image/gif">
<link rel="icon" href="favicon.gif" type="image/gif">
</head><body>
<?
require_once("./lib/users.php");
require_once("./lib/links.php");

if (!isLoggedIn())
	exit("Not logged in");
if (floor($_SESSION['rm_userlevel']) < 10)
	exit("Not an admin (" . $_SESSION['rm_userlevel'] . ")");
$users = new Users;
$users->loadUsers();
$op = isset($_POST['op']) ? $_POST['op'] : "";
$index = isset($_POST['index']) ? floor($_POST['index']) : -1;

if (strcmp($op, "add") == 0) {
	$user = new User;
	$user->name = $_POST['name'];
	$user->level = floor($_POST['level']);
	$user->passwordHash = md5($_POST['password']);
	$users->addUser($user);
} elseif (strcmp($op, "remove") == 0) {
	$users->removeUser($index);
} elseif (strcmp($op, "promote") == 0) {
	$users->alterLevel($index, 5);
} elseif (strcmp($op, "demote") == 0) {
	$users->alterLevel($index, -5);
}
readOnlyWarning();
?>
<small><a href="admin.php">&lt;== back to admin</a></small>
<h2>Users for <?= $siteName ?></h2>
<form method="post" name="userList">
<input type="hidden" name="op" />
<input type="hidden" name="index" />
<table border="0" cellspacing="0" cellpadding="3">
<? for ($i=0; $i<sizeof($users->users); $i++) { ?>
	<tr>
	<td><?= $users->users[$i]->name ?></td>
	<td><? switch($users->users[$i]->level) {
case 5: print("Editor"); break;
case 10: print("Administrator"); break;
default: print("Unknown - " . $users->users[$i]->level); break;
} ?></td>
	<td>[<a href="#" onclick="return removeItem(<?= $i ?>);">remove</a>]
		[<a href="#" onclick="return promote(<?= $i ?>, 5);">promote</a>]
		[<a href="#" onclick="return promote(<?= $i ?>, -5);">demote</a>]
		</td>
	</tr>
<? } ?>
</table>
</form>
<? if (sizeof($users->users) == 0) print("(none)<br />"); ?>

<h2>Add User</h2>
<form method="post">
<input type="hidden" name="op" value="add">
<table border="0" cellspacing="0" cellpadding="3">
<tr><td>Name:</td><td><input type="text" name="name" /></td></tr>
<tr><td>Level:</td><td><select name="level"><option value="5">Editor</option><option value="10">Administrator</option></select></td></tr>
<tr><td>Password:</td><td><input type="password" name="password" /></td></tr>
<tr><td></td><td align="right"><input type="submit" value="Add" /></td></tr>
</table>
</form>

<h2>Change Password</h2>
TODO

<script language="JavaScript" type="text/javascript">
function removeItem(i) {
	document.forms['userList'].elements['op'].value = 'remove';
	document.forms['userList'].elements['index'].value = i;
	document.forms['userList'].submit();
	return false;
}
function promote(i, value) {
	document.forms['userList'].elements['op'].value = ((value > 0) ? 'promote' : 'demote');
	document.forms['userList'].elements['index'].value = i;
	document.forms['userList'].submit();
	return false;
}
</script>
</body></html>