<?
// Rookmarks - tool for administering live RSS bookmarks
// Copyright (C) 2007 Brian Enigma <brian@netninja.com>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
include("./lib/links.php");
include("./lib/settings.php");

$links = new Links;
$links->loadLinks();
?>
<html><head><title>Live RSS Bookmarks - Rookmarks</title>
<link rel="shortcut icon" href="favicon.gif" type="image/gif">
<link rel="icon" href="favicon.gif" type="image/gif">
<link rel="alternate" type="application/rss+xml" title="Bookmarks" href="index.xml"/>
</head><body>

<h1><?= $siteName ?></h1>
<p>
<a href="index.xml">Our live RSS bookmarks file</a> will provide Firefox 
(and other supporting browsers and RSS readers) with a dynamic list of
related bookmarks that automatically updates as new content is found.  For
example:
</p>

<div align="center"><img src="livebookmarks-example.png" width="324" hei
ght="233" border="0" alt="example" /></div>

<p>
To add the live bookmarks to your Firefox toolbar, simply click 
on <a href="index.xml">index.xml</a> and in the screen that comes up, 
select "Live Bookmarks" and click on "Subscribe Now."
</p>

<div align="center"><img src="livebookmarks.png" width="452" height="116
" border="0" alt="activate" /></div>

<p>
The current list of links follows:
</p>

<ul>
<? for ($i=0; $i<sizeof($links->links); $i++) { ?>
	<li><a href="<?= $links->links[$i]->url ?>"><?=  $links->links[$i]->title ?></a></li>
<? } ?>
</ul>

<br /><br /><br /><br />
<small><a href="admin.php">administration</a></small>
</body></html>