<?
// Rookmarks - tool for administering live RSS bookmarks
// Copyright (C) 2007 Brian Enigma <brian@netninja.com>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
$siteName = "My Rookmarks Site";
$rookmarksVersion = "1.0";
include_once("./lib/settings.php");
function checkSecurity() {
	// Create a default user database file if not present (or if zero 
	// length, for example if the user accidentally deleted all users)
	if ( (!file_exists("./lib/users.dat")) || (filesize("./lib/users.dat") == 0) ) {
		if (($f = fopen("./lib/users.dat", "w")) === FALSE)
			exit("Error creating user database file");
		//admin:password
		fwrite($f, "admin:10:5f4dcc3b5aa765d61d8327deb882cf99\n");
		fclose($f);
	}
	// Create an .htaccess file to block access to the directory if not present
	if (!file_exists("./lib/.htaccess")) {
		if (($f = fopen("./lib/.htaccess", "w")) === FALSE)
			exit("Error creating htaccess file");
		fwrite($f, "order deny,allow\ndeny from all\n");
		fclose($f);
	}
}
function setSiteName($newName) {
	GLOBAL $readOnly;
	if ($readOnly != 0)
		return;
	if (($f = fopen("./lib/settings.php", "w")) === FALSE)
		exit("Error creating settings file");
	fwrite($f, "<?\n\$siteName = \"" . addslashes($newName) . "\";\n?>");
	fclose($f);
}
// Manually add $readOnly=1 to your settings.php to enable read-only mode for
// demoing the site.
function readOnlyWarning() {
	GLOBAL $readOnly;
	if ($readOnly != 0)
		print("<h3 style=\"color:red;\">This site is running in read-only mode</h3>\n");
}
checkSecurity();
?>